<?php
/**
 * @package	Global Cart Fee for checkout & cart processing
 * @version	3.2.0
 * @author	HikaShop
 * @copyright	(C) 2010-2022 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashopGlobal_cart_fee extends hikashopPlugin {
	var $multiple = true;
	var $name = 'global_cart_fee';

	var $pluginConfig = array(
		'name' => array('HIKA_NAME', 'input'),
		'price' => array('PRICE', 'input'),		//if value has a custom field name, you can enter here either + or - to indicate whether the calculated sum should be shown for information purpose only or add itself to the total
		'value' => array('VALUE', 'input'),		//can be the name of a custom field and in that case the system will sum the values of that field
		'minimum_subtotal' => array('Minimum Subtotal', 'input'),
		'maximum_subtotal' => array('Maximum Subtotal', 'input'),
	);

	/**
	 *
	 */
	public function onAfterCartProductsLoad(&$cart) {
		$plugins = array();
		$this->listPlugins($this->name, $plugins, false, true);

		if(!count($plugins))
			return;

		foreach($plugins as $plugin) {
			$this->pluginParams($plugin);

			if(isset($cart->additional['global_cart_fee_'.$plugin]))
				continue;

			$config = hikashop_config();
			if($config->get('price_with_tax')) {
				$subtotal = $cart->full_total->prices[0]->price_value_with_tax;
			} else {
				$subtotal = $cart->full_total->prices[0]->price_value;
			}
			if(!empty($this->plugin_params->minimum_subtotal) && $this->plugin_params->minimum_subtotal > $subtotal)
				continue;
			if(!empty($this->plugin_params->maximum_subtotal) && $this->plugin_params->maximum_subtotal < $subtotal)
				continue;

			$additional = new stdClass();
			if(!empty($this->plugin_params->name)) {
				$key = strtoupper($this->plugin_params->name);
				if(JText::_($key) != $key)
					$this->plugin_params->name = JText::_($key);
			}

			$additional->name = $this->plugin_params->name;
			$value = $this->plugin_params->value;

			$firstProduct = reset($cart->products);
			if(isset($firstProduct->$value)) {
				$sum = 0;
				foreach($cart->products as $p) {
					$sum += $p->$value;
				}
				if($this->plugin_params->price != '+') {
					if(empty($currencyHelper))
						$currencyHelper = hikashop_get('class.currency');
					$additional->value = $currencyHelper->format($sum, hikashop_getCurrency());
				} else {
					$additional->price_currency_id = hikashop_getCurrency();
					$additional->price_value = $sum;
					$additional->price_value_with_tax = $sum;
				}

			} else {
				$additional->value = $value;
				if(!empty($this->plugin_params->price)) {
					$additional->price_currency_id = hikashop_getCurrency();
					$additional->price_value = $this->plugin_params->price;
					$additional->price_value_with_tax = $this->plugin_params->price;
				} else {
					$additional->price_currency_id = 0;
					$additional->price_value = 0;
					$additional->price_value_with_tax = 0;
				}
			}

			$cart->additional['global_cart_fee_'.$plugin] = $additional;
		}
	}
}